Index: trunk/NEMO/OPA_SRC/TRD/trdicp.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 503)
@@ -4,4 +4,10 @@
    !! Ocean diagnostics:  ocean tracers and dynamic trends
    !!=====================================================================
+   !! History :       !  91-12 (G. Madec)
+   !!                 !  92-06 (M. Imbard) add time step frequency
+   !!                 !  96-01 (G. Madec)  terrain following coordinates
+   !!            8.5  !  02-06 (G. Madec)  F90: Free form and module
+   !!            9.0  !  04-08 (C. Talandier) New trends organization
+   !!----------------------------------------------------------------------
 #if  defined key_trdtra   ||   defined key_trddyn   ||   defined key_esopa
    !!----------------------------------------------------------------------
@@ -9,12 +15,10 @@
    !!   'key_trddyn'                            momentum trends diagnostics
    !!----------------------------------------------------------------------
-
-   !!----------------------------------------------------------------------
-   !!   trd              : verify the basin averaged properties for tra/dyn 
+   !!----------------------------------------------------------------------
+   !!   trd_icp          : compute the basin averaged properties for tra/dyn 
    !!   trd_dwr          : print dynmaic trends in ocean.output file
    !!   trd_twr          : print tracers trends in ocean.output file
    !!   trd_icp_init     : initialization step
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables
@@ -31,26 +35,12 @@
    PRIVATE
 
-   !! * Interfaces
-   INTERFACE trd
+   INTERFACE trd_icp
       MODULE PROCEDURE trd_2d, trd_3d
    END INTERFACE
 
-   !! * Routine accessibility
-   PUBLIC trd                   ! called by step.F90
-   PUBLIC trd_dwr               ! called by step.F90
-   PUBLIC trd_twr               ! called by step.F90
-   PUBLIC trd_icp_init          ! called by opa.F90
-
-   !! * Shared module variables
-#if  defined key_trdtra   &&   defined key_trddyn    ||   defined key_esopa
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trdtra = .TRUE.    !: tracers  trend flag
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trddyn = .TRUE.    !: momentum trend flag
-#elif  defined key_trdtra
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trdtra = .TRUE.    !: tracers  trend flag
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trddyn = .FALSE.   !: momentum trend flag
-#elif  defined key_trddyn
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trdtra = .FALSE.   !: tracers  trend flag
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trddyn = .TRUE.    !: momentum trend flag
-#endif
+   PUBLIC   trd_icp       ! called by trdmod.F90
+   PUBLIC   trd_dwr       ! called by step.F90
+   PUBLIC   trd_twr       ! called by step.F90
+   PUBLIC   trd_icp_init  ! called by opa.F90
 
    !! * Substitutions
@@ -60,10 +50,10 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
 
-   SUBROUTINE trd_2d(ptrd2dx, ptrd2dy, ktrd , ctype)
+   SUBROUTINE trd_2d( ptrd2dx, ptrd2dy, ktrd , ctype, clpas )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE trd_2d  ***
@@ -71,39 +61,27 @@
       !! ** Purpose : verify the basin averaged properties of tracers and/or
       !!              momentum equations at every time step frequency ntrd.
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) ::   ptrd2dx             ! Temperature or U trend 
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) ::   ptrd2dy             ! Salinity    or V trend
+      INTEGER                     , INTENT(in   ) ::   ktrd                ! tracer trend index
+      CHARACTER(len=3)            , INTENT(in   ) ::   ctype               ! momentum ('DYN') or tracers ('TRA') trends
+      CHARACTER(len=3)            , INTENT(in   ), OPTIONAL ::   clpas     ! number of passage
       !!
-      !! ** Method :
-      !!
-      !! History :
-      !!        !  91-12 (G. Madec)
-      !!        !  92-06 (M. Imbard) add time step frequency
-      !!        !  96-01 (G. Madec)  terrain following coordinates
-      !!   8.5  !  02-06 (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-08 (C. Talandier) New trends organization
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      REAL(wp), DIMENSION(jpi,jpj), INTENT( inout ) ::   &
-         ptrd2dx,                      &   ! Temperature or U trend 
-         ptrd2dy                           ! Salinity    or V trend
-
-      INTEGER, INTENT( in ) ::   ktrd      ! tracer trend index
-
-      CHARACTER(len=3), INTENT( in ) ::   &
-         ctype                             ! momentum or tracers trends type
-         !                                 ! 'DYN' or 'TRA'
-
-      !! * Local declarations
-      INTEGER ::   ji, jj        ! loop indices
-      REAL(wp) ::   &
-         zbt, zbtu, zbtv,     &  ! temporary scalars
-         zmsku, zmskv            !    "         "
-      !!----------------------------------------------------------------------
-
-      ! 1. Advective trends and forcing trend
-      ! -------------------------------------
-
-      ! 1.1 Mask the forcing trend and substract it from the vertical diffusion trend
-      SELECT CASE (ctype)
-
-      CASE ('DYN')              ! Momentum
+      INTEGER  ::   ji, jj                                                 ! loop indices
+      CHARACTER(len=3) ::   cpas                                           ! number of passage
+      REAL(wp) ::   zmsku, zbtu, zbt                                       ! temporary scalars
+      REAL(wp) ::   zmskv, zbtv                                            !    "         "
+      !!----------------------------------------------------------------------
+
+      ! Control of optional arguments
+      cpas = 'fst'
+      IF( PRESENT(clpas) )  cpas = clpas
+
+      ! 1. Mask trends
+      ! --------------
+
+      SELECT CASE( ctype )
+      !
+      CASE( 'DYN' )              ! Momentum
          DO jj = 1, jpjm1
             DO ji = 1, jpim1
@@ -116,23 +94,23 @@
          ptrd2dx(jpi, : ) = 0.e0      ;      ptrd2dy(jpi, : ) = 0.e0
          ptrd2dx( : ,jpj) = 0.e0      ;      ptrd2dy( : ,jpj) = 0.e0
-
-      CASE ('TRA')              ! Tracers
+         !
+      CASE( 'TRA' )              ! Tracers
          ptrd2dx(:,:) = ptrd2dx(:,:) * tmask_i(:,:)
          ptrd2dy(:,:) = ptrd2dy(:,:) * tmask_i(:,:)
-
+         !
       END SELECT
       
-      ! 2. Basin averaged tracer trend
-      ! ------------------------------
-
-      SELECT CASE (ctype)
-
-      CASE ('DYN')              ! Momentum
+      ! 2. Basin averaged tracer/momentum trends
+      ! ----------------------------------------
+
+      SELECT CASE( ctype )
+      !
+      CASE( 'DYN' )              ! Momentum
          umo(ktrd) = 0.e0
          vmo(ktrd) = 0.e0
-
-         SELECT CASE (ktrd)
-
-         CASE (jpdtdswf)         ! surface forcing
+         !
+         SELECT CASE( ktrd )
+         !
+         CASE( jpdyn_trd_swf )         ! surface forcing
             DO jj = 1, jpj
                DO ji = 1, jpi
@@ -141,6 +119,6 @@
                END DO
             END DO
-
-         CASE (jpdtdbfr)         ! bottom friction fluxes
+            !
+         CASE( jpdyn_trd_bfr )         ! bottom friction fluxes
             DO jj = 1, jpj
                DO ji = 1, jpi
@@ -149,10 +127,12 @@
                END DO
             END DO
-
+            !
          END SELECT
-
-      CASE ('TRA')              ! Tracers
-         tmo(ktrd) = 0.e0
-         smo(ktrd) = 0.e0
+         !
+      CASE( 'TRA' )              ! Tracers
+         IF( cpas == 'fst' )   THEN
+            tmo(ktrd) = 0.e0
+            smo(ktrd) = 0.e0
+         ENDIF
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -162,14 +142,14 @@
             END DO
          END DO
-
+         !
       END SELECT
       
-      ! 3. Basin averaged tracer square trend
-      ! -------------------------------------
+      ! 3. Basin averaged tracer/momentum square trends
+      ! ----------------------------------------------
       ! c a u t i o n: field now
       
-      SELECT CASE (ctype)
-
-      CASE ('DYN')              ! Momentum
+      SELECT CASE( ctype )
+      !
+      CASE( 'DYN' )              ! Momentum
          hke(ktrd) = 0.e0
          DO jj = 1, jpj
@@ -182,8 +162,10 @@
             END DO
          END DO
-
-      CASE ('TRA')              ! Tracers
-         t2(ktrd) = 0.e0
-         s2(ktrd) = 0.e0
+         !
+      CASE( 'TRA' )              ! Tracers
+         IF( cpas == 'fst' )   THEN
+            t2(ktrd) = 0.e0
+            s2(ktrd) = 0.e0
+         ENDIF
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -193,12 +175,11 @@
             END DO
          END DO
-      
+         !      
       END SELECT
-
+      !
    END SUBROUTINE trd_2d
 
 
-
-   SUBROUTINE trd_3d(ptrd3dx, ptrd3dy, ktrd, ctype)
+   SUBROUTINE trd_3d( ptrd3dx, ptrd3dy, ktrd, ctype, clpas )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE trd_3d  ***
@@ -206,39 +187,26 @@
       !! ** Purpose : verify the basin averaged properties of tracers and/or
       !!              momentum equations at every time step frequency ntrd.
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptrd3dx            ! Temperature or U trend 
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptrd3dy            ! Salinity    or V trend
+      INTEGER,                          INTENT(in   ) ::   ktrd               ! momentum or tracer trend index
+      CHARACTER(len=3),                 INTENT(in   ) ::   ctype              ! momentum ('DYN') or tracers ('TRA') trends
+      CHARACTER(len=3),                 INTENT(in   ), OPTIONAL ::   clpas    ! number of passage
       !!
-      !! ** Method :
-      !!
-      !! History :
-      !!        !  91-12 (G. Madec)
-      !!        !  92-06 (M. Imbard) add time step frequency
-      !!        !  96-01 (G. Madec)  terrain following coordinates
-      !!   8.5  !  02-06 (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-08 (C. Talandier) New trends organization
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   &
-          ptrd3dx,                     &   ! Temperature or U trend 
-          ptrd3dy                          ! Salinity    or V trend
-
-      INTEGER, INTENT( in ) ::   ktrd      ! momentum or tracer trend index
-
-      CHARACTER(len=3), INTENT( in ) ::   &
-         ctype                             ! momentum or tracers trends type
-         !                                 ! 'DYN' or 'TRA'
-
-      !! * Local declarations
       INTEGER ::   ji, jj, jk
-      REAL(wp) ::   &
-         zbt, zbtu, zbtv,               &  ! temporary scalars
-         zmsku, zmskv
-      !!----------------------------------------------------------------------
-
-      ! 1. Advective trends and forcing trend
-      ! -------------------------------------
-
-      ! Mask the trends
-      SELECT CASE (ctype)
-
-      CASE ('DYN')              ! Momentum        
+      CHARACTER(len=3) ::   cpas                                              ! number of passage
+      REAL(wp) ::   zbt, zbtu, zbtv, zmsku, zmskv                             ! temporary scalars
+      !!----------------------------------------------------------------------
+
+      ! Control of optional arguments
+      cpas = 'fst'
+      IF( PRESENT(clpas) )  cpas = clpas
+
+      ! 1. Mask the trends
+      ! ------------------
+
+      SELECT CASE( ctype )
+      !
+      CASE( 'DYN' )              ! Momentum        
          DO jk = 1, jpk
             DO jj = 1, jpjm1
@@ -248,25 +216,24 @@
                   ptrd3dx(ji,jj,jk) = ptrd3dx(ji,jj,jk) * zmsku
                   ptrd3dy(ji,jj,jk) = ptrd3dy(ji,jj,jk) * zmskv
-               ENDDO
-            ENDDO
-         ENDDO
-
+               END DO
+            END DO
+         END DO
          ptrd3dx(jpi, : ,:) = 0.e0      ;      ptrd3dy(jpi, : ,:) = 0.e0
          ptrd3dx( : ,jpj,:) = 0.e0      ;      ptrd3dy( : ,jpj,:) = 0.e0
-
-      CASE ('TRA')              ! Tracers
+         !
+      CASE( 'TRA' )              ! Tracers
          DO jk = 1, jpk
             ptrd3dx(:,:,jk) = ptrd3dx(:,:,jk) * tmask(:,:,jk) * tmask_i(:,:)
             ptrd3dy(:,:,jk) = ptrd3dy(:,:,jk) * tmask(:,:,jk) * tmask_i(:,:)
-         ENDDO
-
+         END DO
+         !
       END SELECT   
 
-      ! 2. Basin averaged tracer/momentum trend
-      ! ---------------------------------------
+      ! 2. Basin averaged tracer/momentum trends
+      ! ----------------------------------------
       
-      SELECT CASE (ctype)
-
-      CASE ('DYN')              ! Momentum
+      SELECT CASE( ctype )
+      !
+      CASE( 'DYN' )              ! Momentum
          umo(ktrd) = 0.e0
          vmo(ktrd) = 0.e0
@@ -281,8 +248,10 @@
             END DO
          END DO
-
-      CASE ('TRA')              ! Tracers
-         tmo(ktrd) = 0.e0
-         smo(ktrd) = 0.e0
+         !
+      CASE( 'TRA' )              ! Tracers
+         IF( cpas == 'fst' )   THEN
+            tmo(ktrd) = 0.e0
+            smo(ktrd) = 0.e0
+         ENDIF
          DO jk = 1, jpkm1
             DO jj = 1, jpj
@@ -294,14 +263,14 @@
             END DO
          END DO
-
+         !
       END SELECT
 
-      ! 3. Basin averaged tracer/momentum square trend
-      ! ----------------------------------------------
+      ! 3. Basin averaged tracer/momentum square trends
+      ! -----------------------------------------------
       ! c a u t i o n: field now
       
-      SELECT CASE (ctype)
-
-      CASE ('DYN')              ! Momentum
+      SELECT CASE( ctype )
+      !
+      CASE( 'DYN' )              ! Momentum
          hke(ktrd) = 0.e0
          DO jk = 1, jpk
@@ -316,8 +285,10 @@
             END DO
          END DO
-
-      CASE ('TRA')              ! Tracers
-         t2(ktrd) = 0.e0
-         s2(ktrd) = 0.e0
+         !
+      CASE( 'TRA' )              ! Tracers
+         IF( cpas == 'fst' )   THEN
+            t2(ktrd) = 0.e0
+            s2(ktrd) = 0.e0
+         ENDIF
          DO jk = 1, jpk
             DO jj = 1, jpj
@@ -329,7 +300,7 @@
             END DO
          END DO
-
+         !
       END SELECT
-
+      !
    END SUBROUTINE trd_3d
 
@@ -340,26 +311,12 @@
       !!                  ***  ROUTINE trd_icp_init  ***
       !! 
-      !! ** Purpose :   
-      !!
-      !! ** Method  :
-      !!
-      !! History :
-      !!   9.0  !  03-09 (G. Madec)  Original code
-      !!        !  04-08 (C. Talandier) New trends organization
-      !!----------------------------------------------------------------------
-      !! * Local declarations
-      INTEGER :: ji, jj, jk
-
+      !! ** Purpose :   Read the namtrd namelist
+      !!----------------------------------------------------------------------
+      INTEGER  ::   ji, jj, jk
       REAL(wp) ::   zmskt
 #if  defined key_trddyn
-      REAL(wp) ::   zmsku,zmskv
+      REAL(wp) ::   zmsku, zmskv
 #endif
-
-      NAMELIST/namtrd/ ntrd, nctls
-      !!----------------------------------------------------------------------
-
-      ! namelist namtrd : trend diagnostic
-      REWIND( numnam )
-      READ  ( numnam, namtrd )
+      !!----------------------------------------------------------------------
 
       IF(lwp) THEN
@@ -367,16 +324,5 @@
          WRITE(numout,*) 'trd_icp_init : integral constraints properties trends'
          WRITE(numout,*) '~~~~~~~~~~~~~'
-         WRITE(numout,*) ' '
-         WRITE(numout,*) '          Namelist namtrd : '
-         WRITE(numout,*) '             time step frequency trend       ntrd  = ', ntrd
       ENDIF
-
-      ! initialisation of BBL tracers lateral diffusion to zero
-      tldfbbl(:,:) = 0.e0   ;   sldfbbl(:,:) = 0.e0  
-      ! initialisation of BBL tracers lateral advection to zero
-      tladbbl(:,:) = 0.e0   ;   sladbbl(:,:) = 0.e0  
-      ! initialisation of workspace
-      tladi(:,:,:) = 0.e0  ;  tladj(:,:,:) = 0.e0
-      sladi(:,:,:) = 0.e0  ;  sladj(:,:,:) = 0.e0
 
       ! Total volume at t-points:
@@ -392,8 +338,5 @@
       IF( lk_mpp )   CALL mpp_sum( tvolt )   ! sum over the global domain
 
-      IF(lwp) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) '          total ocean volume at T-point   tvolt = ',tvolt
-      ENDIF
+      IF(lwp) WRITE(numout,*) '                total ocean volume at T-point   tvolt = ',tvolt
 
 #if  defined key_trddyn
@@ -419,12 +362,10 @@
 
       IF(lwp) THEN
-         WRITE(numout,*) '          total ocean volume at U-point   tvolu = ',tvolu
-         WRITE(numout,*) '          total ocean volume at V-point   tvolv = ',tvolv
-         WRITE(numout,*) ' '
+         WRITE(numout,*) '                total ocean volume at U-point   tvolu = ',tvolu
+         WRITE(numout,*) '                total ocean volume at V-point   tvolv = ',tvolv
       ENDIF
 #endif
-
+      !
    END SUBROUTINE trd_icp_init
-
 
 
@@ -434,21 +375,10 @@
       !! 
       !! ** Purpose :  write dynamic trends in ocean.output 
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt                                  ! ocean time-step index
       !!
-      !! ** Method  :
-      !!
-      !! History :
-      !!   9.0  !  03-09  (G. Madec)  Original code
-      !!        !  04-08  (C. Talandier)  New trends organization
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
-      INTEGER ::   ji, jj, jk
-      REAL(wp) ::   &
-         ze1e2w,zcof,        &  !    "         "
-         zbe1ru, zbe2rv,     &  !    "         "
-         zbtr, ztz, zth 
-
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-               zkepe, zkx, zky, zkz              ! temporary arrays
+      INTEGER  ::   ji, jj, jk
+      REAL(wp) ::   ze1e2w, zcof, zbe1ru, zbe2rv, zbtr, ztz, zth   !    "      scalars
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zkepe, zkx, zky, zkz   ! temporary arrays
       !!----------------------------------------------------------------------
 
@@ -462,12 +392,12 @@
          ! c a u t i o n here, trends are computed at kt+1 (now , but after the swap)
 
-         zkx(:,:,:) = 0.e0
-         zky(:,:,:) = 0.e0
-         zkz(:,:,:) = 0.e0
+         zkx(:,:,:)   = 0.e0
+         zky(:,:,:)   = 0.e0
+         zkz(:,:,:)   = 0.e0
          zkepe(:,:,:) = 0.e0
    
          CALL eos( tn, sn, rhd, rhop )       ! now potential and in situ densities
 
-         ! 4.1 Density flux at w-point
+         ! Density flux at w-point
          DO jk = 2, jpk
             DO jj = 1, jpj
@@ -478,5 +408,5 @@
             END DO
          END DO
-         zkz  (:,:, 1 ) = 0.e0
+         zkz(:,:,1) = 0.e0
          
          ! Density flux at u and v-points
@@ -524,9 +454,9 @@
          ! ---------------------------------
          IF( lk_mpp ) THEN
-               CALL mpp_sum( peke )
-               CALL mpp_sum( umo , 11 )
-               CALL mpp_sum( vmo , 11 )
-               CALL mpp_sum( hke , 10 )
-         END IF
+            CALL mpp_sum( peke )
+            CALL mpp_sum( umo , jptot_dyn )
+            CALL mpp_sum( vmo , jptot_dyn )
+            CALL mpp_sum( hke , jptot_dyn )
+         ENDIF
 
          ! I.2 Print dynamic trends in the ocean.output file
@@ -537,21 +467,23 @@
             WRITE (numout,*)
             WRITE (numout,9500) kt
-            WRITE (numout,9501) umo( 1) / tvolu, vmo( 1) / tvolv
-            WRITE (numout,9502) umo( 2) / tvolu, vmo( 2) / tvolv
-            WRITE (numout,9503) umo( 3) / tvolu, vmo( 3) / tvolv
-            WRITE (numout,9504) umo( 4) / tvolu, vmo( 4) / tvolv
-            WRITE (numout,9505) umo( 5) / tvolu, vmo( 5) / tvolv
-            WRITE (numout,9506) umo( 6) / tvolu, vmo( 6) / tvolv
-            WRITE (numout,9507) umo( 7) / tvolu, vmo( 7) / tvolv
-            WRITE (numout,9508) umo( 8) / tvolu, vmo( 8) / tvolv
-            WRITE (numout,9509) umo(10) / tvolu, vmo(10) / tvolv
-            WRITE (numout,9510) umo( 9) / tvolu, vmo( 9) / tvolv
-            WRITE (numout,9511) umo(11) / tvolu, vmo(11) / tvolv
+            WRITE (numout,9501) umo(jpicpd_hpg) / tvolu, vmo(jpicpd_hpg) / tvolv
+            WRITE (numout,9502) umo(jpicpd_keg) / tvolu, vmo(jpicpd_keg) / tvolv
+            WRITE (numout,9503) umo(jpicpd_rvo) / tvolu, vmo(jpicpd_rvo) / tvolv
+            WRITE (numout,9504) umo(jpicpd_pvo) / tvolu, vmo(jpicpd_pvo) / tvolv
+            WRITE (numout,9505) umo(jpicpd_ldf) / tvolu, vmo(jpicpd_ldf) / tvolv
+            WRITE (numout,9506) umo(jpicpd_zad) / tvolu, vmo(jpicpd_zad) / tvolv
+            WRITE (numout,9507) umo(jpicpd_zdf) / tvolu, vmo(jpicpd_zdf) / tvolv
+            WRITE (numout,9508) umo(jpicpd_spg) / tvolu, vmo(jpicpd_spg) / tvolv
+            WRITE (numout,9509) umo(jpicpd_swf) / tvolu, vmo(jpicpd_swf) / tvolv
+            WRITE (numout,9510) umo(jpicpd_dat) / tvolu, vmo(jpicpd_dat) / tvolv
+            WRITE (numout,9511) umo(jpicpd_bfr) / tvolu, vmo(jpicpd_bfr) / tvolv
             WRITE (numout,9512)
             WRITE (numout,9513)                                                 &
-            &     (  umo(1) + umo(2) + umo(3) + umo( 4) + umo( 5) + umo(6)    &
-            &      + umo(7) + umo(8) + umo(9) + umo(10) + umo(11) ) / tvolu,   &
-            &     (  vmo(1) + vmo(2) + vmo(3) + vmo( 4) + vmo( 5) + vmo(6)    &
-            &      + vmo(7) + vmo(8) + vmo(9) + vmo(10) + vmo(11) ) / tvolv
+            &     (  umo(jpicpd_hpg) + umo(jpicpd_keg) + umo(jpicpd_rvo) + umo(jpicpd_pvo) + umo(jpicpd_ldf)   &
+            &      + umo(jpicpd_zad) + umo(jpicpd_zdf) + umo(jpicpd_spg) + umo(jpicpd_dat) + umo(jpicpd_swf)   &
+            &      + umo(jpicpd_bfr) ) / tvolu,   &
+            &     (  vmo(jpicpd_hpg) + vmo(jpicpd_keg) + vmo(jpicpd_rvo) + vmo(jpicpd_pvo) + vmo(jpicpd_ldf)   &
+            &      + vmo(jpicpd_zad) + vmo(jpicpd_zdf) + vmo(jpicpd_spg) + vmo(jpicpd_dat) + vmo(jpicpd_swf)   &
+            &      + vmo(jpicpd_bfr) ) / tvolv
          ENDIF
 
@@ -565,5 +497,5 @@
  9507    FORMAT(' vertical diffusion         u= ', e20.13, '    v= ', e20.13)
  9508    FORMAT(' surface pressure gradient  u= ', e20.13, '    v= ', e20.13)
- 9509    FORMAT(' forcing term               u= ', e20.13, '    v= ', e20.13)
+ 9509    FORMAT(' surface wind forcing       u= ', e20.13, '    v= ', e20.13)
  9510    FORMAT(' dampimg term               u= ', e20.13, '    v= ', e20.13)
  9511    FORMAT(' bottom flux                u= ', e20.13, '    v= ', e20.13)
@@ -575,18 +507,18 @@
             WRITE (numout,*)
             WRITE (numout,9520) kt
-            WRITE (numout,9521) hke( 1) / tvolt
-            WRITE (numout,9522) hke( 2) / tvolt
-            WRITE (numout,9523) hke( 3) / tvolt
-            WRITE (numout,9524) hke( 4) / tvolt
-            WRITE (numout,9525) hke( 5) / tvolt
-            WRITE (numout,9526) hke( 6) / tvolt
-            WRITE (numout,9527) hke( 7) / tvolt
-            WRITE (numout,9528) hke( 8) / tvolt
-            WRITE (numout,9529) hke(10) / tvolt
-            WRITE (numout,9530) hke( 9) / tvolt
+            WRITE (numout,9521) hke(jpicpd_hpg) / tvolt
+            WRITE (numout,9522) hke(jpicpd_keg) / tvolt
+            WRITE (numout,9523) hke(jpicpd_rvo) / tvolt
+            WRITE (numout,9524) hke(jpicpd_pvo) / tvolt
+            WRITE (numout,9525) hke(jpicpd_ldf) / tvolt
+            WRITE (numout,9526) hke(jpicpd_zad) / tvolt
+            WRITE (numout,9527) hke(jpicpd_zdf) / tvolt
+            WRITE (numout,9528) hke(jpicpd_spg) / tvolt
+            WRITE (numout,9529) hke(jpicpd_swf) / tvolt
+            WRITE (numout,9530) hke(jpicpd_dat) / tvolt
             WRITE (numout,9531)
             WRITE (numout,9532)   &
-            &     (  hke(1) + hke(2) + hke(3) + hke(4) + hke(5) + hke(6)   &
-            &      + hke(7) + hke(8) + hke(9) + hke(10) ) / tvolt
+            &     (  hke(jpicpd_hpg) + hke(jpicpd_keg) + hke(jpicpd_rvo) + hke(jpicpd_pvo) + hke(jpicpd_ldf)   &
+            &      + hke(jpicpd_zad) + hke(jpicpd_zdf) + hke(jpicpd_spg) + hke(jpicpd_dat) + hke(jpicpd_swf) ) / tvolt
          ENDIF
 
@@ -600,5 +532,5 @@
  9527    FORMAT(' vertical diffusion        u2= ', e20.13)
  9528    FORMAT(' surface pressure gradient u2= ', e20.13)
- 9529    FORMAT(' forcing term              u2= ', e20.13)
+ 9529    FORMAT(' surface wind forcing      u2= ', e20.13)
  9530    FORMAT(' dampimg term              u2= ', e20.13)
  9531    FORMAT(' --------------------------------------------------')
@@ -609,32 +541,32 @@
             WRITE (numout,*)
             WRITE (numout,9540) kt
-            WRITE (numout,9541) ( hke(2) + hke(3) + hke(6) ) / tvolt
-            WRITE (numout,9542) ( hke(2) + hke(6) ) / tvolt
-            WRITE (numout,9543) ( hke(4) ) / tvolt
-            WRITE (numout,9544) ( hke(3) ) / tvolt
-            WRITE (numout,9545) ( hke(8) ) / tvolt
-            WRITE (numout,9546) ( hke(5) ) / tvolt
-            WRITE (numout,9547) ( hke(7) ) / tvolt
-            WRITE (numout,9548) ( hke(1) ) / tvolt, rpktrd / tvolt
+            WRITE (numout,9541) ( hke(jpicpd_keg) + hke(jpicpd_rvo) + hke(jpicpd_zad) ) / tvolt
+            WRITE (numout,9542) ( hke(jpicpd_keg) + hke(jpicpd_zad) ) / tvolt
+            WRITE (numout,9543) ( hke(jpicpd_pvo) ) / tvolt
+            WRITE (numout,9544) ( hke(jpicpd_rvo) ) / tvolt
+            WRITE (numout,9545) ( hke(jpicpd_spg) ) / tvolt
+            WRITE (numout,9546) ( hke(jpicpd_ldf) ) / tvolt
+            WRITE (numout,9547) ( hke(jpicpd_zdf) ) / tvolt
+            WRITE (numout,9548) ( hke(jpicpd_hpg) ) / tvolt, rpktrd / tvolt
+            WRITE (numout,*)
+            WRITE (numout,*)
          ENDIF
 
  9540    FORMAT(' energetic consistency at it= ', i6, ' :', /' =========================================')
  9541    FORMAT(' 0 = non linear term(true if key_vorenergy or key_combined): ', e20.13)
- 9542    FORMAT(' 0 = ke gradient + vertical advection              : ', e20.13)
+ 9542    FORMAT(' 0 = ke gradient + vertical advection                      : ', e20.13)
  9543    FORMAT(' 0 = coriolis term  (true if key_vorenergy or key_combined): ', e20.13)
- 9544    FORMAT(' 0 = uh.( rot(u) x uh ) (true if enstrophy conser.)    : ', e20.13)
- 9545    FORMAT(' 0 = surface pressure gradient                     : ', e20.13)
- 9546    FORMAT(' 0 > horizontal diffusion                          : ', e20.13)
- 9547    FORMAT(' 0 > vertical diffusion                            : ', e20.13)
- 9548    FORMAT(' pressure gradient u2 = - 1/rau0 u.dz(rhop)        : ', e20.13, '  u.dz(rhop) =', e20.13)
-
+ 9544    FORMAT(' 0 = uh.( rot(u) x uh ) (true if enstrophy conser.)        : ', e20.13)
+ 9545    FORMAT(' 0 = surface pressure gradient                             : ', e20.13)
+ 9546    FORMAT(' 0 > horizontal diffusion                                  : ', e20.13)
+ 9547    FORMAT(' 0 > vertical diffusion                                    : ', e20.13)
+ 9548    FORMAT(' pressure gradient u2 = - 1/rau0 u.dz(rhop)                : ', e20.13, '  u.dz(rhop) =', e20.13)
+         !
          ! Save potential to kinetic energy conversion for next time step
          rpktrd = peke
-
+         !
       ENDIF
-
+      !
    END SUBROUTINE trd_dwr
-
-
 
 
@@ -644,14 +576,6 @@
       !! 
       !! ** Purpose :  write active tracers trends in ocean.output 
-      !!
-      !! ** Method  :
-      !!
-      !! History :
-      !!   9.0  !  03-09  (G. Madec)  Original code
-      !!        !  04-08  (C. Talandier)  New trends organization
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
-
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !!----------------------------------------------------------------------
 
@@ -664,8 +588,8 @@
          ! -------------------------------
          IF( lk_mpp ) THEN
-            CALL mpp_sum( tmo, 10 )   
-            CALL mpp_sum( smo, 10 )
-            CALL mpp_sum( t2 , 10 )
-            CALL mpp_sum( s2 , 10 )
+            CALL mpp_sum( tmo, jptot_tra )   
+            CALL mpp_sum( smo, jptot_tra )
+            CALL mpp_sum( t2 , jptot_tra )
+            CALL mpp_sum( s2 , jptot_tra )
          ENDIF
 
@@ -677,17 +601,17 @@
             WRITE (numout,*)
             WRITE (numout,9400) kt
-            WRITE (numout,9401) tmo(1) / tvolt, smo(1) / tvolt
-            WRITE (numout,9402) tmo(2) / tvolt, smo(2) / tvolt
-            WRITE (numout,9403) tmo(3) / tvolt, smo(3) / tvolt
-            WRITE (numout,9404) tmo(4) / tvolt, smo(4) / tvolt
-            WRITE (numout,9405) tmo(5) / tvolt, smo(5) / tvolt
-            WRITE (numout,9406) tmo(6) / tvolt, smo(6) / tvolt
-            WRITE (numout,9407) tmo(7) / tvolt
-            WRITE (numout,9408) tmo(8) / tvolt, smo(8) / tvolt
-            WRITE (numout,9409)
-            WRITE (numout,9410) (  tmo(1) + tmo(2) + tmo(3) + tmo(4)              &
-            &                    + tmo(5) + tmo(6) + tmo(7) + tmo(8) ) / tvolt,   &
-            &                   (  smo(1) + smo(2) + smo(3) + smo(4)              &
-            &                    + smo(5) + smo(6)           + smo(8) ) / tvolt
+            WRITE (numout,9401) (tmo(jpicpt_xad)+tmo(jpicpt_yad))/ tvolt, (smo(jpicpt_xad)+smo(jpicpt_yad))/ tvolt
+            WRITE (numout,9402)  tmo(jpicpt_zad) / tvolt, smo(jpicpt_zad) / tvolt
+            WRITE (numout,9403)  tmo(jpicpt_ldf) / tvolt, smo(jpicpt_ldf) / tvolt
+            WRITE (numout,9404)  tmo(jpicpt_zdf) / tvolt, smo(jpicpt_zdf) / tvolt
+            WRITE (numout,9405)  tmo(jpicpt_npc) / tvolt, smo(jpicpt_npc) / tvolt
+            WRITE (numout,9406)  tmo(jpicpt_dmp) / tvolt, smo(jpicpt_dmp) / tvolt
+            WRITE (numout,9407)  tmo(jpicpt_qsr) / tvolt
+            WRITE (numout,9408)  tmo(jpicpt_nsr) / tvolt, smo(jpicpt_nsr) / tvolt
+            WRITE (numout,9409) 
+            WRITE (numout,9410) (  tmo(jpicpt_xad) + tmo(jpicpt_yad) + tmo(jpicpt_zad) + tmo(jpicpt_ldf) + tmo(jpicpt_zdf)   &
+            &                    + tmo(jpicpt_npc) + tmo(jpicpt_dmp) + tmo(jpicpt_qsr) + tmo(jpicpt_nsr) ) / tvolt,   &
+            &                   (  smo(jpicpt_xad) + smo(jpicpt_yad) + smo(jpicpt_zad) + smo(jpicpt_ldf) + smo(jpicpt_zdf)   &
+            &                    + smo(jpicpt_npc) + smo(jpicpt_dmp)                   + smo(jpicpt_nsr) ) / tvolt
          ENDIF
 
